package nckd.wnq01.wnq.scm.plugin.form;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.resource.ResManager;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.ShowType;
import kd.bos.form.cardentry.CardEntry;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.ClickListener;
import kd.bos.form.control.events.RowClickEventListener;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.fi.er.business.ext.enums.ErExtcaseEnum;
import kd.fi.er.business.ext.helper.ErExtHelper;
import kd.fi.er.business.utils.CalculateTripSumUtil;
import kd.fi.er.business.utils.ErEntityTypeUtils;
import kd.fi.er.common.ShowPageUtils;
import kd.fi.er.formplugin.web.TripBaseBillEdit;
import kd.fi.er.model.FormModel;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: Boil
 * @Date: 2025/5/11 01:02
 * @Version: v1.0.0
 * @Description: 价格批量调整单（新）编辑插件
 **/
public class BatchPriceAdjBaseEditPlugin extends AbstractBillPlugIn implements Plugin, ClickListener, RowClickEventListener, BeforeF7SelectListener {

    @Override
    public void beforeF7Select(BeforeF7SelectEvent beforeF7SelectEvent) {

    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners(new String[]{"nckd_updatetripentry", "nckd_cardentryflexpanel12", "nckd_addtjlabel1", "nckd_addptentry"});
        Control tripEntry = this.getControl("nckd_putentry");
        if (tripEntry instanceof CardEntry) {
            ((CardEntry)tripEntry).addRowClickListener(this);
        }
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        String key = ((Control)evt.getSource()).getKey();
        //String entityId = this.getView().getEntityId();
        IDataModel model = this.getModel();
        //DynamicObject dataEntity = model.getDataEntity();
        //String billStatus = dataEntity.getString("billstatus");
        switch (key) {
            case "nckd_updatetripentry":
                int tripEntryIndex = model.getEntryCurrentRowIndex("nckd_putentry");
                this.openPtEntry(tripEntryIndex, true);
                break;
            case "nckd_cardentryflexpanel12":
            case "nckd_addtriplabel1":
            case "nckd_addptentry":
                this.openPtEntry(-1, true);
                break;
        }
    }

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.propertyChanged(e);
    }

    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        super.closedCallBack(closedCallBackEvent);
    }


    public void openPtEntry(int tripEntryRowIndex, boolean isEnable) {
        IDataModel model = this.getModel();
        String formName = model.getDataEntityType().getName();
        Map<String, Object> customParam = new HashMap();
        customParam.put("tripEntryRowIndex", tripEntryRowIndex);
        customParam.put("formId", formName);
        customParam.put("isEnable", isEnable);
        FormModel formModel = new FormModel(this.getPtEntryEditForm(), ResManager.loadKDString("普调信息", "BatchPriceAdjBaseEdit_0", "scm-sm-formplugin", new Object[0]), "1", true, customParam);
        formModel.setShowType(ShowType.Modal);

        ShowPageUtils.showPage(formModel, this);

    }

    protected String getPtEntryEditForm() {
        return "nckd_ptentryedit";
    }
}
