package nckd.poc602.plugin.operate;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;
import kd.sys.ricc.common.util.StringUtils;

/**
 * 收款处理审核时反写和撤销销售订单中的已收金额
 */
public class RecBillAuditOperationServicePlugIn extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        e.getFieldKeys().add("entry");
        e.getFieldKeys().add("entry.e_corebilltype");
        e.getFieldKeys().add("entry.e_corebillno");
        e.getFieldKeys().add("entry.e_receivableamt");
        e.getFieldKeys().add("entry.e_actamt");
    }
    
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
    	// TODO Auto-generated method stub
    	super.beforeExecuteOperationTransaction(e);
    }
    
    private void updateSaleOrderInfo(AfterOperationArgs e, DynamicObject[] payBills, Boolean iswriteback) {
		Set<DynamicObject> scs = new HashSet<>();
		List<Object> xsddbillnos = new ArrayList<>();
		List<Object> xshtid = new ArrayList<>();
 		for(DynamicObject payBill : payBills) {
			DynamicObjectCollection entrys = payBill.getDynamicObjectCollection("entry");
			for(DynamicObject entry : entrys) {
				String e_corebilltype = entry.getString("e_corebilltype");
				String e_corebillno = entry.getString("e_corebillno");
				if("sm_salorder".equals(e_corebilltype) && StringUtils.isNotBlank(e_corebillno)) {
					xsddbillnos.add(e_corebillno);
				}
				DynamicObject nckd_refbillfield1 = entry.getDynamicObject("nckd_refbillfield1");
				if(nckd_refbillfield1 != null) {
					Object nckd_refbillid = nckd_refbillfield1.getPkValue();
					xshtid.add(nckd_refbillid);
				}
			}
		}
		
		if(!xsddbillnos.isEmpty()) {
			QFilter qf = new QFilter("billno",QCP.in,xsddbillnos);
			DynamicObject[] xsddarray = BusinessDataServiceHelper.load("sm_salorder", "id,billno,recplanentry.r_itemname,recplanentry.r_recamount", qf.toArray());
			for(DynamicObject payBill : payBills) {
				DynamicObjectCollection entrys = payBill.getDynamicObjectCollection("entry");
				for(DynamicObject entry : entrys) {
					String e_corebillno = entry.getString("e_corebillno");
					BigDecimal e_receivableamt = entry.getBigDecimal("e_actamt");//应收金额->实收金额
					DynamicObject nckd_payname = entry.getDynamicObject("nckd_payname");//项目名称
					if(StringUtils.isNotBlank(e_corebillno)) {
						DynamicObject srsTemp = null;
						for(DynamicObject xsdd : xsddarray) {
							String xxddbillno = xsdd.getString("billno");
							if(xxddbillno.equals(e_corebillno)) {
								srsTemp = xsdd;
								break;
							}
						}
						
						if(srsTemp != null) {
							DynamicObjectCollection recplanentry = srsTemp.getDynamicObjectCollection("recplanentry");
							for(DynamicObject recplan : recplanentry) {
								DynamicObject r_itemname = recplan.getDynamicObject("r_itemname");
								if(nckd_payname != null && r_itemname != null && r_itemname.getPkValue().equals(nckd_payname.getPkValue())) {
									BigDecimal r_recamount = recplan.getBigDecimal("r_recamount");//已收金额
									if(iswriteback) {
										BigDecimal r_recamountNew = r_recamount.add(e_receivableamt);
										recplan.set("r_recamount", r_recamountNew);
									}else {
										BigDecimal r_recamountNew = r_recamount.subtract(e_receivableamt);
										recplan.set("r_recamount", r_recamountNew);
									}
									scs.add(srsTemp);
								}
							}
						}
					}
				}
			}

			if(!scs.isEmpty()) {
				SaveServiceHelper.update(scs.toArray(new DynamicObject[0]));
			}
		}
		Set<DynamicObject> xshts = new HashSet<>();
		if(!xshtid.isEmpty()) {
			QFilter qf = new QFilter("id",QCP.in,xshtid);
			DynamicObject[] xsddarrays = BusinessDataServiceHelper.load("conm_salcontract", "id,billno,receiptallamount", qf.toArray());
			for(DynamicObject xsddarray : xsddarrays) {
				for(DynamicObject payBill : payBills) {
					DynamicObjectCollection entrys = payBill.getDynamicObjectCollection("entry");
					for(DynamicObject entry : entrys) {
						BigDecimal e_receivableamt = entry.getBigDecimal("e_actamt");//应收金额->实收金额
						DynamicObject nckd_refbillfield1 = entry.getDynamicObject("nckd_refbillfield1");//销售合同
						if(nckd_refbillfield1 != null && xsddarray.getPkValue().equals(nckd_refbillfield1.getPkValue())) {
							BigDecimal receiptallamount = xsddarray.getBigDecimal("receiptallamount");//已收金额
							if(iswriteback) {
								BigDecimal receiptallamountNew = receiptallamount.add(e_receivableamt);
								xsddarray.set("receiptallamount", receiptallamountNew);
							}else {
								BigDecimal receiptallamountNew = receiptallamount.subtract(e_receivableamt);
								xsddarray.set("receiptallamount", receiptallamountNew);
							}
							xshts.add(xsddarray);
						}
					}
				}
			}
		}
		
		if(!xshts.isEmpty()) {
			SaveServiceHelper.update(xshts.toArray(new DynamicObject[0]));
		}
    }
    
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
    	// TODO Auto-generated method stub
    	super.beginOperationTransaction(e);
    }

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
    }
    
    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
    	// TODO Auto-generated method stub
    	super.afterExecuteOperationTransaction(e);
    	DynamicObject[] payBills = e.getDataEntities();
    	String opkey = e.getOperationKey();
    	if("audit".equals(opkey)) {
    		this.updateSaleOrderInfo(e, payBills, true);
    	}else if("unaudit".equals(opkey)){
    		this.updateSaleOrderInfo(e, payBills, false);
    	}
    }
}